/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2008 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.common.action;

import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.common.dto.CmAspUserDto;
import jp.mosp.common.vo.MosPLoginVo;

public class MosPIndexAction extends MosPAction {

	/**
	 * コンストラクタ
	 */
	public MosPIndexAction() {
		super();
		// 共通処理設定
		setNeedSession(false);
		setNeedAspUser(false);
		setNeedUser(false);
		setCheckProcSeq(false);
		setCheckAuth(false);
	}

	/**
	 * アクション
	 */
	public void action() throws Exception {
		// レスポンスタイプ初期化
		request.setAttribute(MospConst.ATT_RESPONASE_TYPE, MospConst.RESPONSE_TYPE_HTML);
		// セッションの取得
		session = request.getSession(true);
		// 初期ページの取得
		getIndexUrl();
		// セッションに情報をセット
		session.setAttribute(MospConst.ATT_ASPUSER, aspUser);
	}

	/**
	 * 遷移先取得処理
	 * @throws Exception
	 */
	protected void getIndexUrl() throws Exception {
		// 設定ファイルのASP設定によって処理を分岐
		aspUser = new CmAspUserDto();
		// ロゴファイルの設定
		setUseLogo();
		switch (MospUtility.getAspFlag(cfg)) {
		case 0:
			// 0：ASP(xユーザー:1アプリ)
			// ASPのアクションクラスに処理を委譲あるいはそのままJSPへ飛ばしてしまうか。
			//MospUtility.getActionInstance(ctl, "test");
			//break;
		case 1:
			// 1：ASP(1ユーザー:1アプリ)
			// ASPログインページへ遷移
			break;
		case 2:
			// 2：非ASP
			initNonAspUser();
			break;
		default:
			throw new MospException(MospConst.EX_ASP_PROPERTIES);
		}
	}

	protected MosPLoginVo getInitVo() {
		return new MosPLoginVo();
	}

	/**
	 * 非ASP
	 */
	protected void initNonAspUser() {
		// ASPユーザー情報をセット
		createAspUser();
		MosPLoginVo vo = getInitVo();
		vo.initVo(cfg, msg, cmd, aspUser, null);
		vo.setUserId("");
		vo.setPass("");
		// VO及び遷移先をセット
		setVo(vo);
		setUrl(vo.getRetUrl());
	}

}
